/*
 * Aggiornamento : 6/06/2011 aggiunta degli ascoltatori sulle righe della tabella dei contatti
 * 					gestite con un vettore
 * 				   Aggiunga dell'icona al file jar nella cartella data inserita nella cartella src	
 * */
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.*;
import java.util.*;

import javax.swing.*;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;
import javax.swing.table.TableModel;




public class Finestra extends JFrame
{
 
	private static Vector elenco = new Vector (1,1); //vettore che conterr le voci del file
	private static String nomeFile = ""; //conterr il nome del file da aprire
	private static final String msg = "Messaggio : "; //stringa iniziale per i messaggi delle azioni effettuate
	private static boolean modificato = false; //serve per gestire se salvare o no il file 
	private static String estensioneFile = ""; //estensione del file
	private static String percorso = ""; //percorso dell'ultima cartella aperta
	private static String nomeFileTemp = ""; //nome del file senza percorso
	
	private JPanel pannello = new JPanel(); //pannello principale
	
	private JMenuBar mb = new JMenuBar (); //barra dei menu
	//voci della barra dei menu 
	private JMenu file = new JMenu ("File");
	private static JMenu modifica = new JMenu ("Modifica");
	private static JMenu cerca = new JMenu ("Cerca");
	private JMenu help = new JMenu ("Help");
	//item del menu file
	private JMenuItem apri_ = new JMenuItem ("Apri");
	private JMenuItem nuovo_ = new JMenuItem ("Nuovo");
	private static JMenuItem salva_ = new JMenuItem ("Salva");

	private JMenuItem chiudi_ = new JMenuItem ("Chiudi");
	//item del menu modifica
	private JMenuItem inserisci_ = new JMenuItem ("Inserisci");
	private static JMenuItem rinomina_ = new JMenuItem ("Rinomina");
	private static JMenuItem elimina_ = new JMenuItem ("Elimina");
	//item del menu cerca
	private JMenuItem ricerca_ = new JMenuItem ("Ricerca");
	private JMenuItem visualizza_ = new JMenuItem ("Visualizza");
	//item del menu help
	private JMenuItem info_ = new JMenuItem("Info");
	
	private static JLabel messaggi = new JLabel(); //messaggi
	 
	static DefaultTableModel model = null; //da utilizzare per gestire la JTable in modo dinamico
	private JTable tabella = null; //tabella che conterr i dati per la visualizzazione
	private JScrollPane scrollPaneTabella; //scroll della tabella
	
	static String nomiColonne[] = {"ind.","Cognome","Nome"}; //nomi delle colonne della tabella
	
	private static String pathPrincipale = System.getProperty("user.home")+"/ElencoAlunni"; //cartella che contiene i file utili al programma
	
	static String tabStringhe[][] = new String[elenco.size()][nomiColonne.length];
	
	private static Vector elencoVisualizzato = new Vector();

	
	public Finestra () //costruttore
		{			
		    File fp = new File (pathPrincipale);
		    if(!fp.exists()) 
		    	{
		    	 if (fp.mkdir())
		    		 System.out.println("cartella creata");
		    	 else System.out.println("errore nella creazione");
		    	
		    	}
		    //aggiunta degli item ai menu
			file.add(apri_);
			file.add(nuovo_);
			file.add(salva_);

			file.addSeparator();
			file.add(chiudi_);
			modifica.add(inserisci_);
			modifica.add(rinomina_);
			modifica.add(elimina_);
			cerca.add(ricerca_);
			cerca.add(visualizza_);
			help.add(info_);
			//aggiunta dei menu alla menubar
			mb.add(file);
			mb.add(modifica);
			mb.add(cerca);
			mb.add(help);
			//mnemonici per i tasti rapidi
		 	file.setMnemonic('f');
		 	modifica.setMnemonic('m');
		 	cerca.setMnemonic('c'); 
		 	help.setMnemonic('h');
		 	apri_.setMnemonic('a');
		 	nuovo_.setMnemonic('n');
		 	salva_.setMnemonic('s');

		 	chiudi_.setMnemonic('c');
		 	inserisci_.setMnemonic('i');
		 	rinomina_.setMnemonic('r');
		 	elimina_.setMnemonic('e');
		 	ricerca_.setMnemonic('r');
		 	visualizza_.setMnemonic('v');
		 	info_.setMnemonic('i');
		 	this.setJMenuBar(mb);   // aggiunta del menubar al pannello  
		 	
		 	//associazione degli ascoltatori sugli item dei menu
		 	Ascoltatore oggettoAscoltatore = new Ascoltatore();
		  	apri_.addActionListener(oggettoAscoltatore);
		  	nuovo_.addActionListener(oggettoAscoltatore);
		  	salva_.addActionListener(oggettoAscoltatore); 
		  	chiudi_.addActionListener(oggettoAscoltatore);  	
		  	inserisci_.addActionListener(oggettoAscoltatore);  	
		  	rinomina_.addActionListener(oggettoAscoltatore);  	
		  	elimina_.addActionListener(oggettoAscoltatore);  	
		  	ricerca_.addActionListener(oggettoAscoltatore);  	
		  	visualizza_.addActionListener(oggettoAscoltatore); 
		  	info_.addActionListener(oggettoAscoltatore);
		  	
		  	salva_.setEnabled(false);
		  	//esporta.setEnabled(false);
		  	modifica.setEnabled(false);
		  	cerca.setEnabled(false);

		  	//final String tabStringhe[][]= new String[elenco.size()][nomiColonne.length];
		  	caricaTabella(elenco,tabStringhe); //caricamento dei dati da inserire nella tabella
		  	
		    //creazione della tabella con model
		    model = new DefaultTableModel(tabStringhe,nomiColonne){
		    	public boolean isCellEditable(int row , int coll) {return false;} 
		    };
		    
		    
		    
		  	tabella = new JTable( model);
		  	TableColumn column = tabella.getColumnModel().getColumn(0); // indice
		  	column.setPreferredWidth(20);
		  	column = tabella.getColumnModel().getColumn(1); // Cognome
		  	column.setPreferredWidth(200);
		  	column = tabella.getColumnModel().getColumn(2); // Nome
		  	column.setPreferredWidth(200);

		  	
		  	tabella.addMouseListener(new MouseAdapter(){ //aggiunta degli ascoltatori sulle righe della tabella
		  		public void mouseClicked(MouseEvent evt)
		  			{
		  				JTable jt = (JTable)evt.getSource();
		  				if(evt.getClickCount() == 2)
		  					{
		  					gestoreRinomina(Integer.parseInt(elencoVisualizzato.elementAt(jt.getSelectedRow()).toString()));
		  					}
		  			}
		  	});
		  	 
		  	//Visual.message(System.getProperty("user.home")); ritorna la cartella user
		  	scrollPaneTabella = new JScrollPane( tabella ); //aggiungo la tabella allo scroll
		  	
		  	messaggi.setText(msg + "Nessun file aperto!!"); //visualizzazione dei messaggi
		  	Image icona = null; //immagine per l'icona del jar
		  	icona = new ImageIcon (getClass().getResource("resources/registro.png")).getImage();//percorso dell'immagine
		  	this.setIconImage(icona); //impostazione dell'immagine alla pagina
		 	this.setVisible(true); //rendo visibile la finestra
		 	this.setTitle("Elenco Alunni"); //titolo della finestra
		 	this.setBounds(50,50,500,530); //posizionamento della finestrapos_x,pos_y, dim_x, dim_y
		    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);  //aggiunta dei tasti di default per chiudere o ridurre la finestra
		    this.addWindowListener(new GestoreFinestra()); //aggiungo gli ascoltatori ai tasti della finestra
		    
		    
		    getContentPane().add( scrollPaneTabella, BorderLayout.CENTER);
		    getContentPane().add(messaggi,  BorderLayout.SOUTH);
		    
		    
		} //fine costruttore
	



	class Ascoltatore implements ActionListener //gestore degli ascolti sugli item
	 {
	  public void actionPerformed(ActionEvent oggettoEvento)
	   {
	   	 String scelta= oggettoEvento.getActionCommand(); //ricavo la stringa 
	   	 //eventi item del menu  file   	 
	   	 if (scelta.equals("Apri")) gestoreApri() ;
	   	 if (scelta.equals("Nuovo")) gestoreNuovo();
	   	 if (scelta.equals("Salva")) gestoreSalva();
	   	 if (scelta.equals("Chiudi")) gestoreChiudi();
	   	 //eventi item del menu modifica
	   	 if (scelta.equals("Inserisci")) gestoreInserisci();
	   	 if (scelta.equals("Rinomina")) gestoreRinomina(-1);  
	   	 if (scelta.equals("Elimina")) gestoreElimina();
	   	 //eventi item del menu cerca
	   	 if (scelta.equals("Visualizza")) gestoreVisualizza();
	   	 if (scelta.equals("Ricerca")) gestoreRicerca();
	   	 //eventi item del menu help
	   	 if (scelta.equals("Info")) gestoreInfo();
	   } 	
	 } //fine classe ascoltatore
	  
	  public static void gestoreChiudi() //chiude il programma e permette di salvare i dati
	  {		  
			if (modificato)
		    	{
				 int scegli = 1;  // 0==> salvi ; 1==> non salvi
				 scegli = Visual.conferma("Salvare le ultime modifiche sul file '" +  nomeFileTemp + estensioneFile + "' ?");
				 if (scegli == 0 && nomeFile.length() > 0)
					 gestoreSalva();
		    	}
		  	System.exit(0);	
	  }//fine gestoreEsci
	  
	  
	  public void gestoreApri () //apre un file gi esistente
	  	{
		    if (modificato) 
		    	{
		    	 int scegli = 1;
		    	 scegli = Visual.conferma("Salvare le ultime modifiche ?");
			     if (scegli == 0)
			    	 gestoreSalva();
		    	}
		    elenco.clear(); //svuoto l'elenco
	    	modificato = false; 
	    	salva_.setEnabled(false);
		    JFileChooser cercaFile = new JFileChooser(); 
            percorso = caricaUltimoPercorso(); //percorso di partenza
            cercaFile.setCurrentDirectory( new File(percorso) ); //imposto il percorso 
		    cercaFile.setDialogTitle("Cerca file"); //titolo della finestra
		    cercaFile.setFileSelectionMode(JFileChooser.FILES_ONLY); //ammetto la selezione solo di file
		    //cercaFile.addChoosableFileFilter(new FiltroEstensioniXML());
		    cercaFile.addChoosableFileFilter(new FiltroEstensioniCSV());
		    //cercaFile.addChoosableFileFilter(new FiltroEstensioniRBC());
		    cercaFile.addChoosableFileFilter(new FiltroEstensioniAmmesse());
		    cercaFile.setAcceptAllFileFilterUsed(false); //accetto solo i file che corrispondono al filtro
		    int result = cercaFile.showOpenDialog(this); 		    
		    if (result == JFileChooser.APPROVE_OPTION)
		      {
		         File f = cercaFile.getSelectedFile();			        
		         String temp = "" + cercaFile.getCurrentDirectory();
			  	 salvaUltimoPercorso(temp);
		         nomeFile = "" + f; //assegno a nomeFile il nome del file da gestire
		         nomeFileTemp = estraiNomeFile(nomeFile);
		         estensioneFile = nomeFile.substring(nomeFile.lastIndexOf("."));		         
		         boolean riuscito = false;
		         if (estensioneFile.equals(".csv"))
		         	{
		        	 riuscito = CSV.leggiCSV(nomeFile , elenco);
		         	}
		         else Visual.message("File non compatibile!!");
		         
		         if (riuscito)
		         	{
			         aggiornaTabella("");
			         abilitaItem();
			         messaggi.setText(msg + " aperto il file : " + nomeFileTemp);
			         this.setTitle("Elenco  : " + nomeFileTemp);
		         	}
		         else {
		        	   messaggi.setText(msg + " Errore durante l'aperturra del file");
		         	   estensioneFile = "";
		         	   }
		      }		 
	  	}//fine gestoreApri
	  
	  
	  public static void abilitaItem()
	  	{
	  		modifica.setEnabled(true);	  		
	  		if (elenco.size() > 0) 
	  			{
	  			 elimina_.setEnabled(true);
	  			 rinomina_.setEnabled(true);
	  			 cerca.setEnabled(true);
	  			}
	  		else 
		  		{
	  			 cerca.setEnabled(false);
	  			 elimina_.setEnabled(false);
	  			 rinomina_.setEnabled(false);
		  		}
	  		}//fine abilitaItem
	  
	  
	  public void gestoreNuovo() //crea un nuovo file
	  	{
		  if (modificato) 
	    	{
	    	 int scegli = 1;
	    	 scegli = Visual.conferma("Salvare le ultime modifiche ?");
		     if (scegli == 0)
		    	 gestoreSalva();
	    	}
		  elenco.clear();
	      modificato = false;
	      salva_.setEnabled(false);
		  JFileChooser cercaFile = new JFileChooser(); 
          percorso = caricaUltimoPercorso(); //percorso di partenza
          cercaFile.setCurrentDirectory( new File(percorso) ); //imposto il percorso 
		  cercaFile.setDialogTitle("Nuovo elenco"); //titolo della finestra
		  //cercaFile.setApproveButtonText("salva");
		  File g = new File ("elenco");///per visualizzare il nome provvisorio del file
		  cercaFile.setSelectedFile(g); ////
		  //cercaFile.addChoosableFileFilter(new FiltroEstensioniXML());
		  cercaFile.setFileFilter(new FiltroEstensioniCSV());
		  //cercaFile.setFileFilter(new FiltroEstensioniRBC());
		  //cercaFile.setFileFilter(new FiltroEstensioniXML());
		  cercaFile.setAcceptAllFileFilterUsed(false);
		  cercaFile.removeChoosableFileFilter (cercaFile.getAcceptAllFileFilter ());//elimino la riga TUTTI I FILE
		  cercaFile.setFileSelectionMode(JFileChooser.FILES_ONLY); //ammetto la selezione solo di file
		  int result = cercaFile.showSaveDialog(this); 
		  boolean riuscito = false;
		  if (result==JFileChooser.APPROVE_OPTION)
		      {
			     String temp = "" + cercaFile.getCurrentDirectory(); //ricavo la directory selezionata
			  	 salvaUltimoPercorso(temp);
		         g = cercaFile.getSelectedFile();
		         if (cercaFile.getFileFilter().getDescription().equals("Rubrica (csv)")) //se selezionato csv
		         	{
		        	  estensioneFile = ".csv"; 
		        	  nomeFile = "" + g + estensioneFile;
		        	  riuscito = CSV.salvaCSV(nomeFile, elenco, false);
		        	 }	         
		         if (riuscito)
		         	{
		        	 nomeFileTemp = estraiNomeFile(nomeFile);
			         messaggi.setText(msg + " Creato nuovo file " + nomeFileTemp);
			         aggiornaTabella("");
			         abilitaItem();
			         this.setTitle("Elenco alunni : " + nomeFileTemp);
		         	}
	             else estensioneFile = "";
		      }
	  	}//fine gestoreNuovo
	  
	  
	  public static void gestoreSalva()
	  	{
		  if (modificato)
			  {
			  if (estensioneFile.equals(".csv"))
			  	{
				  CSV.salvaCSV(nomeFile, elenco ,true);
				  modificato = false;
			  	}
			  }
		  else 
			  Visual.message("Nessuna modifica da salvare !"); 
		  salva_.setEnabled(false);
		  messaggi.setText(msg + " salvataggio effettuane");
	  	}//fine gestore salva
	  
	  

	  
	  
	  
	  public static void gestoreEsportaCsv()
	  	{
		  String nomeTemp = nomeFile.substring(0, nomeFile.length()-4) + ".csv";
		  CSV.salvaCSV(nomeTemp, elenco , false);
	  	}//fine gestoreEsportaCsv
	  
	  
	  
	  public void gestoreInserisci()
	  	{
		  if (nomeFile.length() == 0) Visual.message("Nessuna file aperto!!");
		  else
			  {												//      titolo	nome	cognome	tel	email	nuovo  indice 
			  AggiungiContatto finestra_input = new AggiungiContatto("Nuovo alunno" , "" , ""  , true , -1);  
			  }	  		  
	  	}//fine gestore inserisci
	  
	  
	  public static void riceviOggetto(Contatto nuovo , int pos)
	  	{
		  if (pos < 0)
			  {
			  //Visual.message("Aggiunto nuovo alunno !");
			   elenco.addElement(nuovo);
			   aggiornaTabella("");
			   messaggi.setText(msg + " Nuovo alunno inserito!");
			  }
		  else 
		  	{
			  //Visual.message("Nominativo modificato !");
			  elenco.setElementAt(nuovo, pos);
			  aggiornaTabella("");
			  messaggi.setText(msg + " Nominativo modificato!");
		  	}		  
		  modificato = true;
		  salva_.setEnabled(true);
		  abilitaItem();		  
	  	} //fine riceviOggetto
	  
	  
	  public static void gestoreRinomina(int i)
	   {
		  //gestoreVisualizza();
		  int indice = i;
		  if (i < 0)
			  indice = Visual.readInt("\n Indice dell'alunno da rinominare : "); 	       
		  if (indice < 0 || indice >= elenco.size())
		   	      Visual.message("Indice non corretto !");
		  else 
		  	{
			  Contatto temp = (Contatto) elenco.elementAt(indice);
			  AggiungiContatto modifica_input = new AggiungiContatto("Modifica contatto" ,temp.getNome() , temp.getCognome() , false , indice);
		  	}
	   }//fine gestoreRinomina
	  
	  
	  public static void gestoreElimina()
	  {
	      int indice= Visual.readInt("\n Indice dell'alunno da eliminare : "); 	       
	   	 try
	      { 
	   	   elenco.removeElementAt(indice);    
	   	   aggiornaTabella("");
	   	   messaggi.setText(msg + " Alunno eliminato!!");
	   	   Visual.message("Eliminazione effettuata");   
	   	   modificato = true;
	   	   salva_.setEnabled(true);
	   	   abilitaItem();
	   	 }
	   	 catch (Exception e )
	   	      { 
	   		   Visual.message("Eliminazione NON possibile (indice non valido)!");
	   	       messaggi.setText(msg + " Eliminazione non possibile (indice non valido)!!");
	   	      }     	 	    
	  }  // fine gestoreElimina
	  
	  
	  
	  public void gestoreRicerca() 
	  {
	  	String cerca = Visual.readLine("Alunno da cercare (anche una parte del nome) : ");	  	
	    String cercaMaiuscolo = cerca.substring(0,1).toUpperCase() + cerca.substring(1,cerca.length()).toLowerCase();
	  	int dimensione =  model.getRowCount(); //svuoto la tabella
	     if(dimensione>0) 	
	      for(;;)
	       {
	        int riga= model.getRowCount()-1;
	        model.removeRow(riga); 
	        if (riga==0) break;
	       } 	
	 	if (elenco.size() > 0) //scansiono l'elenco per trovare il contatto con il cognome/nome cercato
	     {
	        elencoVisualizzato.clear();
	 		boolean trovato = false;
	        String tabStringhe[][] = new String[elenco.size()][nomiColonne.length];
	        caricaTabella(elenco,tabStringhe); 
	        Contatto c = null;	            
	        int conta = 0;
	        for(int i=0 ; i < elenco.size() ; i++) 
	        { 
	          c = (Contatto) elenco.elementAt(i);
	          if( c.getCognome().indexOf(cerca) > -1 || 
	        	  c.getNome().indexOf(cerca) > -1 ||
	        	  c.getCognome().indexOf(cercaMaiuscolo) > -1 || 
	        	  c.getNome().indexOf(cercaMaiuscolo) > -1
	        	  )
	           {
	            trovato = true;
	            model.insertRow(conta++, tabStringhe[i]);
	            elencoVisualizzato.addElement(i);
	           }
	        }// fine for
	        if (trovato)
	            messaggi.setText(msg + " Trovate " + conta + " voci con termine " + cerca);
	        else 
	        	messaggi.setText(msg + " nessun nominativo corrispondente a " + cerca);
	     }     	
	  }   // fine gestoreRicerca 
	  
	  
	  
	  public static void gestoreVisualizza()
	  	{
		  aggiornaTabella("");  
	  	}//fine gestoreVisualizza
	  
	  
	  
	  public void gestoreInfo() 
	  	{
		    Info visualizza = new Info();
	  	}//fine gestoreInfo

	 
	  
	  static void caricaTabella(Vector elenco, String tabStringhe[][])
		  {
		  	   Contatto c;
		        for(int i=0;i<elenco.size(); i++) 
		        { c = (Contatto) elenco.elementAt(i);
		 	
		 	     tabStringhe[i][0]= "" + (new Integer(i)).toString();
		 	     tabStringhe[i][1]= "" + c.getCognome();
		 	     tabStringhe[i][2]= "" + c.getNome();
		        }// fine for 	
		  }//fine caricaTabella
	  
	  
	  
	  public static void aggiornaTabella(String messaggio) //aggiornamento della tabella
		  {
		     int dimensione =  model.getRowCount(); //svuotamento della tabella
		     if(dimensione > 0)
		      for(;;)
		      {
		       int riga= model.getRowCount()-1;
		       model.removeRow(riga); 
		       if (riga == 0) break;
		      }
		    ordinaElenco();  //richiamo il metodo che ordina i contatti in ordine alfabetico
		    if (elenco.size()>0)
			   { 
		        elencoVisualizzato.clear();
		    	String tabStringhe[][] = new String[elenco.size()][nomiColonne.length];		    
		        caricaTabella(elenco,tabStringhe);
		        for(int i=0;i<elenco.size(); i++) 
		        	{
		             model.insertRow(i, tabStringhe[i]);
		        	 elencoVisualizzato.addElement(i);
		        	}
		        messaggi.setText(msg + "Dati caricati");		         
		      } 
		     else
		        messaggi.setText(msg + "Elenco vuoto!");
		 	
		  }   // fine aggiornaTabella
	  
	  
	  
	  public static void ordinaElenco() //riordino dell'elenco in ordine alfabetico
	  	{
		  boolean flag = true;
			 int k = elenco.size() - 1 ;
			 while (flag && k > 0)
			 	{
				 flag = false;
				 for (int i = 0 ; i < k ; i++)
				 	{
					 if (((Contatto)elenco.elementAt(i)).getCognome().compareTo(((Contatto)elenco.elementAt(i+1)).getCognome()) > 0  ||
						 ((Contatto)elenco.elementAt(i)).getCognome().compareTo(((Contatto)elenco.elementAt(i+1)).getCognome()) == 0 &&
						 ((Contatto)elenco.elementAt(i)).getNome().compareTo(((Contatto)elenco.elementAt(i+1)).getNome()) >= 0) 
					 	{
						 flag = true;
						 Contatto temp = new Contatto();
						 temp = ((Contatto)elenco.elementAt(i));
						 elenco.set(i, elenco.elementAt(i+1));
						 elenco.set(i+1, temp);
					 	}
				 	}
				 k--;
			 	}
	  	}//fine ordinaElenco
	  

	  
	public static String caricaUltimoPercorso()
	  { //caricamento dell'ultima path aperta dal programma
	    String ultimoPercorso = "";
	    try
	    	{ 
	    	 FileReader fileFisico = new FileReader(pathPrincipale + "/percorso.txt");
	         BufferedReader fileLogico = new BufferedReader(fileFisico);	    	 
	    	 ultimoPercorso = fileLogico.readLine();
		     fileLogico.close();     
	    	}
	    catch(IOException e) 
	    	{ 
	    	 //Visual.message("Problemi in lettura" + e);
	         System.out.println("errore nel caricamento dell'ultima path " + e);
	    	}  
	    return ultimoPercorso;
	  } //fine caricaUltimoPercorso 
	  
	
	
	  public static void salvaUltimoPercorso(String path)
	  {     //salvataggio dell'ultima path aperta nella ricerca dei file delle rubriche
		  try
		     {
			  FileWriter fileFisico = new FileWriter(pathPrincipale + "/percorso.txt");
		      PrintWriter fileLogico = new PrintWriter(fileFisico);
		      fileLogico.println(path);
		      fileLogico.close();
		  	  System.out.println("SALVATO il file  " + nomeFile);
		     }
		  catch(Exception e)
			     { 
		    	  //Visual.message("Eccezione in scrittura file: " + eccez.getMessage());
			  		System.out.println("errore nel salvataggio del path " + e);
			     }
	  } //fine salvaUltimoPercorso
	  
	  
	  
	  public static String estraiNomeFile(String temp)
	  	{  //estraggo solo il nome del file senza path e senza estensione
		  return temp.substring(temp.lastIndexOf("\\") + 1 , temp.length() - 4);		    
	  	}
	  

}//fine classe Finestra



//classe utilizzata per gestire gli eventi sui pulsanti della finestra
class GestoreFinestra implements WindowListener
{
  public void windowIconified(WindowEvent e) {} 
  public void windowDeiconified(WindowEvent e) {} 
  public void windowActivated(WindowEvent e) {} 
  public void windowDeactivated(WindowEvent e) {}   
  public void windowOpened(WindowEvent e) {} 
  public void windowClosed(WindowEvent e) {} 
  
          	 
  public GestoreFinestra() 
  {

  }        	 
          	 
  public void windowClosing(WindowEvent e) 
  {
    Finestra.gestoreChiudi(); //quando viene premuto il tasto chiudi viene richiamato il metodo della classe
    						//finestra che gestisce l'uscita dal programma	
  }
} //fine GestoreFinestra



//classe che visualizza un'area di testo
class Info extends JFrame
	{
	 private JPanel finestraInfo = new JPanel(); //pannello info
     private JTextArea textArea = new JTextArea(10,15);
     private JLabel link = new JLabel("www.");

	 public Info()
	 	{
		 textArea.setText("\n  Programma : ElencoAlunni\n\n" +
		  				  "  Autore : Riontino Raffaele\n "+
		  				  " Data : 16/09/2011\n " + 
		  				  " ITIS Molinari - Milano\n " +
		  				  " 5 informatici (corso serale)\n\n" +
		  				  "  Blog : lelezapp5inf.altervista.org");
		 textArea.setEnabled(false);
		 textArea.setDisabledTextColor(Color.BLUE);
		 getContentPane().add(textArea);
		 this.setBounds(200,200,400,220); //pos_x,pos_y, dim_x, dim_y
		 this.setResizable(false);
		 //this.setDefaultCloseOperation(this.EXIT_ON_CLOSE);
		 this.setVisible(true);
	 	}
	}//fine class Info



    

